--------------------------------------------------------------------------
-- File: BOARD.E
-- 
-- Author: Normand M. Blais
-- Date  : November 30, 1998
-- 
--------------------------------------------------------------------------

include machine.e
include sort.e

global sequence link          
global integer gameover 

global constant TOP = 1, BOTTOM = 4

global constant BOARD = 1
global constant FREELOC = 2
global constant MOVECOUNT = 3
global constant FREESQUARE = 16

constant GAMERECORD = {
{{ 1, 2, 3, 4},
 { 5, 6, 7, 8},
 { 9,10,11,12},
 {13,14,15,16}
},                  
{4,4},
0
}


global 
procedure initGame()
   link = GAMERECORD
   gameover = 0
end procedure

global 
function rotateLeft(integer row)
   integer temp
   if (row = 2 or row = 3 or gameover = 1) then return 0 end if
   temp = link[BOARD][row][1]
   link[BOARD][row][1] = link[BOARD][row][2]
   link[BOARD][row][2] = link[BOARD][row][3]
   link[BOARD][row][3] = link[BOARD][row][4]
   link[BOARD][row][4] = temp
   link[MOVECOUNT] = link[MOVECOUNT] + 1
   if link[FREELOC][1] = row then
      temp = find(FREESQUARE,link[BOARD][row])
      if temp then
         link[FREELOC][2] = temp 
      end if
   end if
   return 1
end function
                 
global 
function rotateRight(integer row)
   integer temp
   if (row = 2 or row = 3 or gameover = 1) then return 0 end if
   temp = link[BOARD][row][4]
   link[BOARD][row][4] = link[BOARD][row][3]
   link[BOARD][row][3] = link[BOARD][row][2]
   link[BOARD][row][2] = link[BOARD][row][1]
   link[BOARD][row][1] = temp
   link[MOVECOUNT] = link[MOVECOUNT] + 1
   if link[FREELOC][1] = row then
      link[FREELOC][2] =  link[FREELOC][2] + 1
   end if
   if link[FREELOC][1] = row then
      temp = find(FREESQUARE,link[BOARD][row])
      if temp then
         link[FREELOC][2] = temp 
      end if
   end if
   return 1
end function

global 
function pushUp()
   integer r0,c0,r,c
   r0 = link[FREELOC][1]
   if r0 = 4 then return 0 end if
   c0 = link[FREELOC][2]
   r = r0+1
   c = c0 
   link[BOARD][r0][c0] = link[BOARD][r][c]
   link[BOARD][r][c] = FREESQUARE
   link[FREELOC] = {r,c}
   link[MOVECOUNT] = link[MOVECOUNT] + 1
   return 1
end function

global 
function pushDown()
   integer r0,c0,r,c
   r0 = link[FREELOC][1]
   if r0 = 1 then return 0 end if
   c0 = link[FREELOC][2]
   r = r0-1
   c = c0 
   link[BOARD][r0][c0] = link[BOARD][r][c]
   link[BOARD][r][c] = FREESQUARE
   link[FREELOC] = {r,c}                  
   link[MOVECOUNT] = link[MOVECOUNT] + 1
   return 1
end function

global
function win() 
   -- not fully debugged?
   sequence s
   integer n1,n2,n3,n4,result
   s = link[BOARD]     
   n1 = s[1][1] + s[2][1] + s[3][1] + s[4][1]       
   n2 = s[1][2] + s[2][2] + s[3][2] + s[4][2]       
   n3 = s[1][3] + s[2][3] + s[3][3] + s[4][3]       
   n4 = s[1][4] + s[2][4] + s[3][4] + s[4][4]
   s = sort(n1 & n2 & n3 & n4)       
   result = 0
   if not compare(s,{28,32,36,40}) then
       if not compare(sort(link[BOARD][1]),{1,2,3,4}) then
           if not compare(sort(link[BOARD][4]),{13,14,15,16}) then
               result = 1
           end if
       elsif not compare(sort(link[BOARD][1]),{1,2,3,16}) then
           if not compare(sort(link[BOARD][4]),{12,13,14,15}) then
               result = 1
           end if
       end if
   end if
   return result
end function

global
procedure scramble(integer n)
   integer r,z
--   set_rand(12345)
   for i=1 to n do
      r = remainder(rand(n),6) + 1
      if r = 1 then
          z=rotateLeft(1)
      elsif r = 2 then
          z=rotateLeft(4)
      elsif r = 3 then
          z=rotateRight(1)
      elsif r = 4 then
          z=rotateRight(4)
      elsif r = 5 then
          z=pushDown()
      elsif r = 6 then
          z=pushUp()
      end if
   end for
   link[MOVECOUNT] = 0
end procedure

