--------------------------------------------------------------------------
-- File: LINK.EX
-- 
-- Author: Normand M. Blais
-- Date  : December 3, 1998
-- 
--------------------------------------------------------------------------
without trace
without type_check
without warning

include font.e -- Jiri Babor
include screen.e
include get.e
include mouse.e 
include image.e
include putsxy.e -- David Alan Gay

integer sc24,mo28
mo28 = load_font("modern28.f")
sc24 = load_font("scotia24.f")


sequence Cursors

Cursors=    --Initialize the mouse cursor variables
    {{
        #FF,#FF,#FF,#F3,#FF,#E1,#FF,#E1,#FF,#E1,#FF,#E1,#07,#E0,#00,#E0,
        #00,#80,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#80,#03,#C0,
        #00,#00,#00,#0C,#00,#12,#00,#12,#00,#12,#B0,#13,#4E,#12,#49,#12,
        #49,#72,#49,#92,#01,#90,#01,#80,#01,#80,#01,#80,#02,#40,#FC,#3F}, 
        5, 0,
    {
        #FF,#3F,#FF,#1F,#FF,#0F,#FF,#07,#FF,#03,#FF,#01,#FF,#00,#7F,#00,
        #3F,#00,#1F,#00,#0F,#00,#07,#00,#47,#18,#7F,#38,#3F,#FC,#7F,#FE,
        #00,#00,#00,#40,#00,#60,#00,#70,#00,#78,#00,#7C,#00,#7E,#00,#7F,
        #80,#7F,#C0,#7F,#E0,#7F,#30,#67,#00,#43,#00,#03,#80,#01,#00,#00}, 
       1, 0}


integer Mouse_Cursor_Store          

Mouse_Cursor_Store = allocate_low(64) 

-- CHANGE_CURSOR() procedure created by Victor Milankovic

procedure Change_cursor(integer CursorNo)
  
  sequence reg_list
  
  reg_list=repeat(0,10)
  poke(Mouse_Cursor_Store, Cursors[(CursorNo-1)*3+1])
  reg_list[REG_AX]=#0009
  reg_list[REG_BX]=Cursors[(CursorNo-1)*3+2]
  reg_list[REG_CX]=Cursors[(CursorNo-1)*3+3]
  reg_list[REG_ES]=floor(Mouse_Cursor_Store /16)
  reg_list[REG_DX]=remainder(Mouse_Cursor_Store,16)
  reg_list=dos_interrupt(#33, reg_list)

end procedure

procedure video_18()
  if graphics_mode(18) then   -- 640 x 480  16 colors
     puts(1,"Can't get good graphics mode.\n")
     abort(1)
  end if
end procedure

procedure restore_video()  
    if graphics_mode(-1)then
    end if
end procedure

procedure drawButton(integer x, integer y, integer xlen, integer ylen,
                     sequence label, integer bg_color, integer fg_color)
    integer xl,yl
    xl = x + 8
    yl = y + 8
    putsxy({xl,yl}, label, fg_color,bg_color,2)
    polygon(YELLOW,0,{{x,y},{x+xlen,y},{x+xlen,y+ylen},{x,y+ylen}})
end procedure

constant BUTTONXLEN = 80, BUTTONYLEN = 30,
         NEWGAMEX1  = ORIG[1]+6*STEP-40,
         NEWGAMEX2  = NEWGAMEX1+BUTTONXLEN, 
         NEWGAMEY1  = ORIG[2], 
         NEWGAMEY2  = NEWGAMEY1+BUTTONYLEN,
         QUITX1 = ORIG[1]+6*STEP-40, 
         QUITX2 = QUITX1+BUTTONXLEN, 
         QUITY1 = ORIG[2]+60, 
         QUITY2 = QUITY1+BUTTONYLEN

constant RTLX1  = ORIG[1]-STEP,   RTLX2 = ORIG[1], 
         RTLY1  = ORIG[2]-STEP,   RTLY2 = ORIG[2]+STEP,
         RTRX1  = ORIG[1]+4*STEP, RTRX2 = ORIG[1]+5*STEP, 
         RTRY1  = ORIG[2]-STEP,   RTRY2 = ORIG[2]+STEP,
         RBLX1  = ORIG[1]-STEP,   RBLX2= ORIG[1], 
         RBLY1  = ORIG[2]+3*STEP, RBLY2= ORIG[2]+4*STEP,
         RBRX1  = ORIG[1]+4*STEP, RBRX2= ORIG[1]+5*STEP, 
         RBRY1  = ORIG[2]+3*STEP, RBRY2= ORIG[2]+4*STEP,
         UPX1   = ORIG[1],        UPX2= ORIG[1]+4*STEP,
         UPY1   = ORIG[2]-STEP,   UPY2=ORIG[2],        
         DOWNX1 = ORIG[1],        DOWNX2= ORIG[1]+4*STEP,
         DOWNY1 = ORIG[2]+4*STEP, DOWNY2=ORIG[2]+5*STEP

constant ROTATETOPLEFT = 1001,
         ROTATEBOTLEFT = 1002,
         ROTATETOPRIGHT= 1003,
         ROTATEBOTRIGHT= 1004,
         PUSHUP        = 1005,
         PUSHDOWN      = 1006,
         NEWGAME       = 1007,
         QUIT          = 1008,
         DONOTHING     = 2000

function whereIsMouse(sequence s)
   integer x,y
   x = s[1] y = s[2]
   if x>RTLX1 and x<RTLX2 and y>RTLY1 and y<RTLY2 then
      return ROTATETOPLEFT 
   elsif x>RTRX1 and x<RTRX2 and y>RTRY1 and y<RTRY2 then
      return ROTATETOPRIGHT 
   elsif x>RBLX1 and x<RBLX2 and y>RBLY1 and y<RBLY2 then
      return ROTATEBOTLEFT 
   elsif x>RBRX1 and x<RBRX2 and y>RBRY1 and y<RBRY2 then
      return ROTATEBOTRIGHT 
   elsif x>UPX1 and x<UPX2 and y>UPY1 and y<UPY2 then
      return PUSHUP
   elsif x>DOWNX1 and x<DOWNX2 and y>DOWNY1 and y<DOWNY2 then
      return PUSHDOWN   
   elsif x>NEWGAMEX1 and x<NEWGAMEX2 and y>NEWGAMEY1 and y<NEWGAMEY2 then
      return NEWGAME
   elsif x>QUITX1 and x<QUITX2 and y>QUITY1 and y<QUITY2 then
      return QUIT
   else
      return DONOTHING
   end if
end function

procedure DoNothing() 
   return
end procedure    

procedure NewGame() 
   gameover = 0
   scramble(1000)
   drawBoard()
end procedure

procedure eventLoop()
    object spare
    object me        
    integer what2do
    while 1 do
       spare = get_key()
       if spare != -1 then
           exit
       end if
       me = get_mouse()
       if sequence(me) then  
          if (me[2] > ORIG[1]-STEP and me[2] < ORIG[1] and  
              me[3] > ORIG[2] and me[3] < ORIG[2]+STEP ) or

             (me[2] > ORIG[1]-STEP and me[2] < ORIG[1] and  
              me[3] > ORIG[2]+3*STEP and me[3] < ORIG[2]+MAXLEN ) or

             (me[2] > ORIG[1]+MAXLEN and me[2] < ORIG[1]+MAXLEN+STEP and  
              me[3] > ORIG[2] and me[3] < ORIG[2]+STEP ) or

             (me[2] > ORIG[1]+MAXLEN and me[2] < ORIG[1]+MAXLEN+STEP and  
              me[3] > ORIG[2]+3*STEP and me[3] < ORIG[2]+MAXLEN ) or

             (me[2] > ORIG[1] and me[2] < ORIG[1]+MAXLEN and  
              me[3] > ORIG[2]-STEP and me[3] < ORIG[2] ) or

             (me[2] > ORIG[1] and me[2] < ORIG[1]+MAXLEN and  
              me[3] > ORIG[2]+MAXLEN and me[3] < ORIG[2]+MAXLEN+STEP ) then
              Change_cursor(1)
          else
              Change_cursor(2)
          end if
          if and_bits(me[1], LEFT_UP) then
                what2do = whereIsMouse(me[2] & me[3])
                if what2do = ROTATETOPLEFT and not gameover then
                   mouse_pointer(0)
                   RotateLeft(1)
                   mouse_pointer(1)          
                elsif what2do = ROTATETOPRIGHT and not gameover then
                   mouse_pointer(0)
                   RotateRight(1)
                   mouse_pointer(1)          
                elsif what2do = ROTATEBOTLEFT  and not gameover then
                   mouse_pointer(0)
                   RotateLeft(4)
                   mouse_pointer(1)          
                elsif what2do = ROTATEBOTRIGHT and not gameover then
                   mouse_pointer(0)
                   RotateRight(4)
                   mouse_pointer(1)          
                elsif what2do = PUSHUP         and not gameover then
                   mouse_pointer(0)
                   PushUp()
                   mouse_pointer(1)          
                elsif what2do = PUSHDOWN       and not gameover then
                   mouse_pointer(0)
                   PushDown()
                   mouse_pointer(1)          
                elsif what2do = NEWGAME         then
                   mouse_pointer(0)
--                   putsxy({150,400},
--                   sprintf("Congratulations, YOU solved the puzzle in %d moves",
--                   link[MOVECOUNT]),MAGENTA,MAGENTA,2)
                   setx(30) sety(400)
                   select_font(mo28)
                   set_foreground(MAGENTA)
                   write(sprintf("Congratulations, YOU solved the puzzle in %d moves!",link[MOVECOUNT]))
                   NewGame()
                   mouse_pointer(1)          
                elsif what2do = QUIT            then
                   exit
                elsif what2do = DONOTHING then
                   DoNothing() 
                end if
                if link[MOVECOUNT] > 0 then
                    gameover = win()
                    if gameover then
                       mouse_pointer(0)
--                       putsxy({150,400},
--                       sprintf("Congratulations, YOU solved the puzzle in %d moves",
--                       link[MOVECOUNT]),MAGENTA,BRIGHT_GREEN,2)
                       setx(30) sety(400)
                       select_font(mo28)
                       set_foreground(YELLOW)
                       write(sprintf("Congratulations, YOU solved the puzzle in %d moves!",link[MOVECOUNT]))
                       mouse_pointer(1)
                    end if
                end if
          end if
       end if
   end while
end procedure

procedure runApplication()
    object x
    initGame()
    video_18()
    clear_screen()
    init_putsxy() -- added by Robert Craig 11/02/98
    x = palette(RED,{50,2,15})
    x = palette(BLUE,{1,2,40})
    x = palette(GREEN,{0,43,1})
    x = palette(YELLOW,{60,60,32})
    x = palette(MAGENTA,{12,31,31})
    polygon(MAGENTA,1,{{0,0},{639,0},{639,479},{0,479}})
    drawBoard()
    gameover = 1                             
    drawButton(NEWGAMEX1, NEWGAMEY1, BUTTONXLEN, BUTTONYLEN, 
               "NEW GAME", MAGENTA,BRIGHT_GREEN)
    drawButton(QUITX1, QUITY1, BUTTONXLEN, BUTTONYLEN, 
               "  QUIT  ", MAGENTA,BRIGHT_RED)
    -- Jiri's
    setx(170) sety(26)
    select_font(sc24)
    set_foreground(7)
    write("LINK PUZZLE by N.Blais")
    --
    mouse_events(LEFT_UP+MOVE)
    Change_cursor(2)  -- 1=hand 2=arrow
    mouse_pointer(1)
    eventLoop()
    mouse_pointer(0)
    restore_video()  
end procedure


runApplication()


